/*********************************************
	average.c
    
   input: double buffer
   output: double buffer averaged (replace)
   note nx, ny should be odd numbers

   programmed by Dr. Hoonyol Lee
   5 March 2002 
	
   modifiend to double
   19 April 2002

   memory allocation
   extreme extra memory saving: 
	[nrow*ncol] -> [nrow_buf*ncol]
   21 May 2004
**********************************************/
/*
#include <math.h>
#include "ma.c"
*/

void averge(data, nrow, ncol, nx, ny)
double *data;
int ncol, nrow, nx, ny;
{

	double *buf, tmp;
	int i, j, k, l, kx, ncount;
	int nrow_buf, ibuf, ibufx, ri, rix; 

	nrow_buf= ny/2+1; /* number of buffer row */
	buf = dvector(nrow_buf*ncol);

	for(i=0; i< (nrow+nrow_buf); i++)
	{
	   /* new buffer row */
	   ibuf = fmod(i, nrow_buf);
	   ibufx = ibuf*ncol;
 
	   /* replace this row to data */
	   ri = i - nrow_buf;
	   if(ri>=0)
	   {
		rix=ri*ncol;
      		for(j=0; j<ncol; j++) 
			data[rix+j]=buf[ibufx+j];
	   }
	
	   /* make new averaged row */	
	   if(i<nrow)
	   {
	   	for(j=0; j<ncol; j++)
	   	{
		   tmp = 0.; 
		   ncount = 0;
		   for(k=i-ny/2; k<=i+ny/2; k++)
		   {
		   	kx=k*ncol;
		   	for(l=j-nx/2; l<=j+nx/2; l++)
			   if(k>=0 && k<nrow && l>=0 && l<ncol)
			   {
				tmp += data[kx+l];
				ncount ++;
			   }
		   }
		   buf[ibufx+j] = tmp/ncount;
	   	}
	   }

	}

	free(buf);
}
		 


		
