/*****************************************************
	azimuth_matched_filter.c

 1. Perform azimuth matched filtering in FFT
 2. Given
	z1 = x1 + jy1 (FFTed azimuth chirp)
	z2 = x2 + jy2 (FFTed data),
    this program calculates
	z1*z2 = (x1*x2-y1*y2) + j(x1*y2+x2+y1). 


by Dr. Hoonyol Lee
Department of Geophysics
Kangwon National University

coding initiated 7 May 2004 
*******************************************************/

void azimuth_matched_filter()
{
	int i, j, ix;
	double x1, y1, x2, y2;

	printf(" azimuth_matched_filter:\n");

	for(i=0; i<nazimuth_fft; i++)
	{
		ix = i*nrange_fft*2;
		x1 = azimuth_chirp_data[2*i];
		y1 = azimuth_chirp_data[2*i+1];
		for(j=0; j<nrange_fft; j++)
		{	
		    x2 = data[ix+2*j];
		    y2 = data[ix+2*j+1];

		    data[ix+2*j] = x1*x2 - y1*y2;
		    data[ix+2*j+1] = x1*y2 + x2*y1;
		}
	}

}

