/**********************************
 1D-FFT of 2D complex Data 
 H. Lee, 17/7/01 
 modified usgin ma.c, 7 May 2004
 Normalize in case of iFFT, 21 May 2004

   data:
   nrow, ncol:

   iflag:  0 --- x directional FFT
	   1 --- y directional FFT

   isign:  1 --- forward FFT
          -1 --- inverse FFT
**********************************/

/*#include "ma.c"*/
#include "twon.c"
#include "dfour1.c"

void fft(data, nrow, ncol, iflag, isign)
double *data;
int nrow, ncol, iflag, isign;
{
	unsigned long nn;
	int i,j, linen;
	double *tmp;

	linen = ncol*2; 
	if(iflag == 0)		/* x-directional FFT */ 
	{
		tmp = dvector(ncol*2+1);
		nn = twon(ncol);
        	for(i=0; i<nrow; i++){
               	 	for(j=0; j<ncol; j++){
               	         	tmp[2*j+1] = data[linen*i + 2*j];
               		        tmp[2*j+2] = data[linen*i + 2*j + 1];
                	}
                	dfour1(tmp, nn, isign);
                	for(j=0; j<ncol; j++){
                        	data[linen*i+2*j] = tmp[2*j+1];
                        	data[linen*i+2*j+1] = tmp[2*j+2];
        		}

		}
	
		if(isign==-1)
			for(i=0; i<nrow*ncol*2; i++) data[i] /= ncol;

	}

	if(iflag == 1)		/* y-directional FFT */ 
	{
		tmp = dvector(nrow*2+1);
		nn = twon(nrow);
		for(i=0; i< ncol; i++){	
			for(j=0; j<nrow; j++){
				tmp[2*j+1] = data[linen*j+2*i]; 
				tmp[2*j+2] = data[linen*j+2*i+1];
			}
			dfour1(tmp, nn, isign);
			for(j=0; j<nrow; j++){
				data[linen*j+2*i] = tmp[2*j+1];
				data[linen*j+2*i+1] = tmp[2*j+2];
			}
		}

		if(isign==-1)
			for(i=0; i<nrow*ncol*2; i++) data[i] /= nrow;
	
	}

}


