void gen_ers (fname, nrow, ncol, drow, dcol, nband, bflag)
char fname[], bflag[];
int  ncol, nrow, nband;
double drow, dcol;
{
        char fnamers[80];
        FILE *fp;
        int i, nbyte;

        strcpy(fnamers, fname);
        strcat(fnamers, ".ers");
        fp = fopen(fnamers, "w");

        fprintf(fp,"DatasetHeader Begin\n");
        fprintf(fp,"        Version         = \"6.0\"\n");
        fprintf(fp,"        Name  	    = \"%s\"\n", fnamers);
        fprintf(fp,"        Description	    = \"Generated by Hoonyol Lee\"\n");
        fprintf(fp,"        LastUpdated     = Thu Jun 12 00:00:00 GMT 2004\n");
        fprintf(fp,"        SensorName      = \"Unknown\"\n");
        fprintf(fp,"        SenseDate       = Thu Jun 12 00:00:00 GMT 2004\n");
        fprintf(fp,"        DataSetType     = ERStorage\n");
        fprintf(fp,"        DataType        = Raster\n");
        fprintf(fp,"        ByteOrder       = LSBFirst\n");
        fprintf(fp,"        CoordinateSpace Begin\n");
        fprintf(fp,"                Datum           = \"RAW\"\n");
        fprintf(fp,"                Projection      = \"RAW\"\n");
        fprintf(fp,"                Projection      = \"RAW\"\n");
        fprintf(fp,"                CoordinateType  = RAW\n");
        fprintf(fp,"                Rotation        = 0:0:0.0\n");
        fprintf(fp,"        CoordinateSpace End\n");
        fprintf(fp,"        RasterInfo Begin\n");

        if(strncmp(bflag, "010", 3) == 0) 
                fprintf(fp,"                CellType        = Unsigned8BitInteger\n");
        else if(strncmp(bflag, "110",3) == 0) 
                fprintf(fp,"                CellType        = Signed8BitInteger\n");
        else if(strncmp(bflag, "020",3) == 0) 
                fprintf(fp,"                CellType        = Unsigned16BitInteger\n");
        else if(strncmp(bflag, "120",3) == 0) 
                fprintf(fp,"                CellType        = Signed16BitInteger \n");
        else if(strncmp(bflag, "040",3) == 0) 
                fprintf(fp,"                CellType        = Unsigned32BitInteger\n");
        else if(strncmp(bflag, "140",3) == 0) 
                fprintf(fp,"                CellType        = Signed32BitInteger \n");
        else if(strncmp(bflag, "141",3) == 0) 
                fprintf(fp,"                CellType        = IEEE4ByteReal\n");
        else if(strncmp(bflag, "181",3) == 0) 
                fprintf(fp,"                CellType        = IEEE8ByteReal\n");
	else
	{	nbyte = atoi(bflag); 
                fprintf(fp,"                CellType        = Unsigned%dBitInteger\n", nbyte);
	}

        fprintf(fp,"                CellInfo Begin\n");
        fprintf(fp,"                        Xdimension      = %lf\n", dcol);
        fprintf(fp,"                        Ydimension      = %lf\n", drow);
        fprintf(fp,"                CellInfo End\n");
        fprintf(fp,"                NrOfLines       = %d\n", nrow);
        fprintf(fp,"                NrOfCellsPerLine        = %d\n", ncol);
        fprintf(fp,"                NrOfBands       = %d\n", nband);

        for(i=0; i<nband; i++){ 
                fprintf(fp,"                BandId Begin\n");
                fprintf(fp,"                        Value           = \"Band%d\"\n", i+1);
                fprintf(fp,"                BandId End\n");
        }
  
        fprintf(fp,"        RasterInfo End\n");
        fprintf(fp,"DatasetHeader End\n");
        fclose(fp);
}


void ers_usage()
{
        printf(" Usage: gen_ers datafile nrow ncol nband bit_flag(or nbyte)\n ");
        printf("\n");
        printf("        where datafile : input file name\n");
        printf("                  nrow : number of row\n");
        printf("                  ncol : number of column\n");
        printf("                 nband : number of band\n\n");    
        printf("                 nbyte : number of byte per cell\n\n");    
        printf("              bit_flag : bit flag\n\n");
        printf("                         number of byte, or \n");
        printf("                         010   Unsigned  8 bit Integer\n"); 
        printf("                         110     Signed  8 bit Integer\n"); 
        printf("                         020   Unsigned 16 bit Integer\n"); 
        printf("                         120     Signed 16 bit Integer\n"); 
        printf("                         040   Unsigned 32 bit Integer\n"); 
        printf("                         140     Signed 32 bit Integer\n"); 
        printf("                         141       IEEE  4 Byte Real\n"); 
        printf("                         181       IEEE  8 Byte Real\n"); 
	printf("\n");
}

