/*  load_para.c

	1. Load parameter files
	2. Derive relevant paramters
	2. Allocate memory
*/

void load_para(char *fname_para)
{

	FILE *fp;
	char vbuf[80];
	int i, malloc_total;

	printf(" load_para:\n");	

	/* Input variables from the parameter file */
	if((fp=fopen(fname_para, "r")) == NULL)
	{
		printf("  (Error) Cannot open %s.\n\a", fname_para);
		exit(0);
	}

	printf("  <Input Parameters>\n");

	fscanf(fp, "%s %s", vbuf, fname_in);
	printf("  %s= %s\n", vbuf, fname_in);

	fscanf(fp, "%s %s", vbuf, fhead);
	printf("  %s= %s\n", vbuf, fhead);

	fscanf(fp, "%s %d", vbuf, &nrange_whole);
	printf("  %s= %d\n", vbuf, nrange_whole);
	
	fscanf(fp, "%s %d", vbuf, &nazimuth_whole);
	printf("  %s= %d\n", vbuf, nazimuth_whole);

	fscanf(fp, "%s %d", vbuf, &nbyte_per_record);
	printf("  %s= %d\n", vbuf, nbyte_per_record);

	fscanf(fp, "%s %d", vbuf, &nskip_record);
	printf("  %s= %d\n", vbuf, nskip_record);

	fscanf(fp, "%s %d", vbuf, &nskip_byte_per_record);
	printf("  %s= %d\n", vbuf, nskip_byte_per_record);

	fscanf(fp, "%s %d", vbuf, &range_start);
	printf("  %s= %d\n", vbuf, range_start);

	fscanf(fp, "%s %d", vbuf, &range_end);
	printf("  %s= %d\n", vbuf, range_end);
	
	fscanf(fp, "%s %d", vbuf, &nrange);
	printf("  %s= %d\n", vbuf, nrange);
	
	fscanf(fp, "%s %d", vbuf, &azimuth_start);
	printf("  %s= %d\n", vbuf, azimuth_start);

	fscanf(fp, "%s %d", vbuf, &azimuth_end);
	printf("  %s= %d\n", vbuf, azimuth_end);

	fscanf(fp, "%s %d", vbuf, &nazimuth);
	printf("  %s= %d\n", vbuf, nazimuth);

	fscanf(fp, "%s %d", vbuf, &nrange_fft);
	printf("  %s= %d\n", vbuf, nrange_fft);

	fscanf(fp, "%s %d", vbuf, &nazimuth_fft);
	printf("  %s= %d\n", vbuf, nazimuth_fft);

	fscanf(fp, "%s %lf", vbuf, &carrier_frequency);
	printf("  %s= %g Hz\n", vbuf, carrier_frequency);

	fscanf(fp, "%s %lf", vbuf, &chirp_rate);
	printf("  %s= %g Hz/s\n", vbuf, chirp_rate);

	fscanf(fp, "%s %lf", vbuf, &chirp_duration);
	printf("  %s= %g s\n", vbuf, chirp_duration);

	fscanf(fp, "%s %lf", vbuf, &range_sampling_frequency);
	printf("  %s= %g Hz\n", vbuf, range_sampling_frequency);

	fscanf(fp, "%s %lf", vbuf, &pulse_repetition_frequency);
	printf("  %s= %g Hz\n", vbuf, pulse_repetition_frequency);

	fscanf(fp, "%s %lf", vbuf, &nominal_mean_I);
	printf("  %s= %g\n", vbuf, nominal_mean_I);

	fscanf(fp, "%s %lf", vbuf, &nominal_mean_Q);
	printf("  %s= %g\n", vbuf, nominal_mean_Q);

	fscanf(fp, "%s %lf", vbuf, &DC_bias_I);
	printf("  %s= %g\n", vbuf, DC_bias_I);

	fscanf(fp, "%s %lf", vbuf, &DC_bias_Q);
	printf("  %s= %g\n", vbuf, DC_bias_Q);

	fscanf(fp, "%s %lf", vbuf, &range_first_time);
	printf("  %s= %g s\n", vbuf, range_first_time);

	fscanf(fp, "%s %lf", vbuf, &range_centre_time);
	printf("  %s= %g s\n", vbuf, range_centre_time);

	fscanf(fp, "%s %lf", vbuf, &range_last_time);
	printf("  %s= %g s\n", vbuf, range_last_time);

	fscanf(fp, "%s %lf", vbuf, &satellite_radius);
	printf("  %s= %g m\n", vbuf, satellite_radius);
	
	fscanf(fp, "%s %lf", vbuf, &satellite_velocity);
	printf("  %s= %g m/s\n", vbuf, satellite_velocity);
	
	fscanf(fp, "%s %lf", vbuf, &satellite_squint_radian);
	printf("  %s= %g\n", vbuf, satellite_squint_radian);
	
	fscanf(fp, "%s %lf", vbuf, &antenna_azimuth_length);
	printf("  %s= %g m\n", vbuf, antenna_azimuth_length);
	
	fscanf(fp, "%s %lf", vbuf, &nominal_incidence_degree);
	printf("  %s= %g deg\n", vbuf, nominal_incidence_degree);

	fscanf(fp, "%s %lf %lf", vbuf, &Doppler_centroid0, &Doppler_centroid1);
	printf("  %s= %g Hz %g Hz/range_pixel\n", vbuf, Doppler_centroid0,
		Doppler_centroid1);

	fscanf(fp, "%s %lf", vbuf, &Doppler_rate);
	printf("  %s= %g Hz/s\n", vbuf, Doppler_rate);

	fscanf(fp, "%s %d %d", vbuf, &maverage_nx, &maverage_ny);
	printf("  %s= %d %d\n", vbuf, maverage_nx, maverage_ny);

	fscanf(fp, "%s %d", vbuf, &multilook_azsample);
	printf("  %s= %d\n", vbuf, multilook_azsample);
	
	fscanf(fp, "%s %d", vbuf, &oerm);
	printf("  %s= %d\n", vbuf, oerm); /* oerm=1 : enable ERMapper output */
	
	for(i=0; i<16; i++)
	  fscanf(fp, "%d", &oflag[i]);
	
	fclose(fp);

  	/* Generic Parameters */
	cspeed=2.997925e8;
	pi = 4.*atan(1.); 	
	earth_radius_major = 6378144.;
	earth_radius_minor = 6356759.;

	printf("\n  <Generic Parameters>\n");
	printf("  cspeed= %g m/s\n", cspeed);
	printf("  pi= %g\n", pi);
	printf("  earth_radius_major= %g m\n", earth_radius_major);
	printf("  earth_radius_minor= %g m\n", earth_radius_minor);

	/* Induced Parameters */
	delta_t= 1./range_sampling_frequency;  
		/* range data sampling interval (sec) */
	delta_s= 1./pulse_repetition_frequency; 
		/* azimuth data sampling interval (sec) */	
	wavelength= cspeed/carrier_frequency; /* lambda (m) */

	satellite_velocity_effective = satellite_velocity *
		sqrt(earth_radius_major/satellite_radius);

	nominal_incidence_radian=nominal_incidence_degree*pi/180.;

	range_pixel_size=cspeed*delta_t/2.; /* delta_Rs (m)*/
	ground_range_pixel_size=range_pixel_size
		/sin(nominal_incidence_radian); /* delta_Rg (m)*/
	azimuth_pixel_size=satellite_velocity_effective*delta_s; 
		/* delta_a (m) */
	
	range_first= range_first_time*cspeed/2.;
		 /* range of the first sample in the whole image (m) */
	range_centre= range_centre_time*cspeed/2.;
	range_last= range_last_time*cspeed/2.;

	range_first_extracted = range_first + range_start*range_pixel_size; 
	range_centre_extracted = range_first + 
		(range_start + range_end)/2.*range_pixel_size; 
	range_last_extracted = range_first + range_end*range_pixel_size;

	Doppler_centroid = Doppler_centroid0+Doppler_centroid1*
		nrange/2;
	Doppler_centroid += 2.*satellite_velocity_effective/wavelength 
			    *sin(satellite_squint_radian);
	
 	/*  Upgrade suggestions:
	     1. satellite_velocity should be changed to the effective one.
	     2. coherent_integration_time need to be changed manually.
	     3. range_bandwidth need to be changed manually.
	*/

	Doppler_rate += (-2.)/wavelength/range_centre_extracted 
			    *satellite_velocity_effective
			    *satellite_velocity_effective;

	coherent_integration_time= wavelength*range_centre_extracted/
		(satellite_velocity_effective*antenna_azimuth_length);

	range_bandwidth=fabs(chirp_rate)*chirp_duration;
	range_time_resolution=1./range_bandwidth;
	slant_range_resolution=cspeed*range_time_resolution/2.;
	ground_range_resolution=slant_range_resolution/
		sin(nominal_incidence_radian);
 	range_compression_ratio=range_bandwidth*chirp_duration;
	
	azimuth_bandwidth=fabs(Doppler_rate)*coherent_integration_time;
	azimuth_time_resolution=1./azimuth_bandwidth;
	azimuth_resolution=satellite_velocity_effective*azimuth_time_resolution;
	azimuth_compression_ratio=azimuth_bandwidth*coherent_integration_time;	

	printf("\n  <Induced Parameters>\n");
	printf("  delta_t= %e s\n", delta_t);
	printf("  delta_s= %e s\n", delta_s);
	printf("  wavelength= %g m\n", wavelength);
	printf("  range_first= %g m\n", range_first);
	printf("  range_centre= %g m\n", range_centre);
	printf("  range_last= %g m\n", range_last);
	printf("  range_first_extracted= %g m\n", range_first_extracted);
	printf("  range_centre_extracted= %g m\n", range_centre_extracted);
	printf("  range_last_extracted= %g m\n", range_last_extracted);
	printf("  satellite_velocity_effective= %g m/s\n",
				satellite_velocity_effective);

	printf("  Doppler_centroid= %g Hz\n", Doppler_centroid);
	printf("  Doppler_rate= %g Hz/s\n", Doppler_rate);
	printf("  coherent_integration_time= %g s\n", coherent_integration_time);
	printf("  range_pixel_size= %g m\n", range_pixel_size);
	printf("  ground_range_pixel_size= %g m\n", ground_range_pixel_size);
	printf("  azimuth_pixel_size= %g m\n", azimuth_pixel_size);
	printf("  range_bandwidth= %g Hz\n", range_bandwidth);
	printf("  azimuth_bandwidth= %g Hz\n", azimuth_bandwidth);
	printf("  range_time_resolution= %g s\n", range_time_resolution);
	printf("  azimuth_time_resolution= %g s\n", azimuth_time_resolution);
	printf("  slant_range_resolution= %g m\n", slant_range_resolution);
	printf("  ground_range_resolution= %g m\n", ground_range_resolution); 
	printf("  azimuth_resolution= %g m\n", azimuth_resolution);
	printf("  range_compression_ratio= %g\n", range_compression_ratio);	
	printf("  azimuth_compression_ratio= %g\n", azimuth_compression_ratio);	

	/* allocate memory */
	malloc_total=0;

	data = dvector(nrange_fft*nazimuth_fft*2); 
	malloc_total += nrange_fft*nazimuth_fft*2*sizeof(double);

	printf("\n  Total memory allocated: %d bytes.\n", malloc_total);

}

	
