/*********************************************
		maverage.c
   
     multi-band average (replace)
 
   input: double BIP
   output: double BIP averaged (replace)
   note nx, ny should be odd numbers

   programmed by Dr. Hoonyol Lee
   5 March 2002 
	
   modifiend to double
   19 April 2002

   memory allocation
   extreme extra memory saving: 
	[nrow*ncol*nband] -> [nrow_buf*ncol*nband]
   21 May 2004
**********************************************/
/*
#include <math.h>
#include "ma.c"
*/

void maverage(data, nrow, ncol, nband, nx, ny)
double *data;
int ncol, nrow, nband, nx, ny;
{

	double *buf, *tmp;
	int i, j, k, l, m, jx, kx, lx, ncount;
	int nrow_buf, ibuf, ibufx, ri, rix; 

	printf(" maverage: %dx%d\n", nx, ny);

	nrow_buf= ny/2+1; /* number of buffer row */
	buf = dvector(nrow_buf*ncol*nband);
	tmp = dvector(nband);

	for(i=0; i< (nrow+nrow_buf); i++)
	{
	   /* buffer row */
	   ibuf = (int)fmod(i, nrow_buf);
	   ibufx = ibuf*ncol*nband;
 
	   /* replace data with this buffer row */
	   ri = i - nrow_buf;
	   if(ri>=0)
	   {
		rix=ri*ncol*nband;
      		for(j=0; j<ncol*nband; j++) 
			data[rix+j]=buf[ibufx+j];
	   }
	
	   /* make new averaged row */	
	   if(i<nrow)
	   {
	   	for(j=0; j<ncol; j++)
	   	{
		   for(m=0; m<nband; m++) tmp[m]=0.;
		   ncount = 0;
		   for(k=i-ny/2; k<=i+ny/2; k++)
		   {
		   	kx=k*ncol*nband;
		   	for(l=j-nx/2; l<=j+nx/2; l++)
			   if(k>=0 && k<nrow && l>=0 && l<ncol)
			   {
				lx=l*nband;
				for(m=0; m<nband; m++)
				   tmp[m] += data[kx+lx+m]; 
				ncount ++;
			   }
		   }
		   jx=j*nband;
		   for(m=0; m<nband; m++)
		      buf[ibufx+jx+m] = tmp[m]/ncount;
	   	}
	   }

	}

	free(buf);
}
		 


		
