/********************************************************
	     multilook_fout.c

	Complex File OUTput program 

		* * *

  multilook_fout(cdata, nrow, ncol, az_sample, ftail)

	1. data (input data): double, AP, BIP 
	2. nrow: number of row
	3. ncol: number of col
	4. az_sample: azimuth sampling length	
 	5. ftail: filename tail (fname=fhead+ftail)			 

by Dr. Hoonyol Lee
Department of Geophysics
Kangwon National University

coding originated from cfout.c on 21 May 2004
*********************************************************/	

void multilook_fout(cdata, nrow, ncol, az_sample, ftail)
double *cdata;
int nrow, ncol, az_sample;
char *ftail;
{

	FILE *fp;
	char fname[80];
	int i, j, ix, nrow_out;
	double x1, y1, amplitude, phase; 
    	float *fbuf;
 
	strcpy(fname, fhead);
	strcat(fname, "_");
	strcat(fname, ftail);

	nrow_out=nrow/az_sample;
	printf(" multilook_fout: %s, %d-look, %d-byte, nrow=%d, ncol=%d\n", 
		fname, az_sample, sizeof(float), nrow_out, ncol);
	
	if((fp=fopen(fname, "w"))==NULL)
	{
		printf(" (Error) Can not open %s.\n", fname);
		exit(0);	
	}

	fbuf=fvector(ncol);
	for(i=0; i<nrow; i+=az_sample)
	{
	   	ix=i*ncol*2;
		for(j=0; j<ncol; j++) fbuf[j]=(float)cdata[ix+2*j];
	 	fwrite(fbuf, 1, ncol*sizeof(float), fp);
	}
	free(fbuf);
	if(oerm==1) gen_ers(fname, nrow, ncol, azimuth_pixel_size,
		ground_range_pixel_size, 1, "141");
	fclose(fp);

}

